/*
 * Created on Aug 16, 2003
 *
 */
package isac.BrowserServlet;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;

import javax.xml.transform.Source;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.stream.StreamSource;

/**
 * @author gismo
 *
 * Encoderclass to build the HTML-Code out of XML-informations using XSLT
 */
public class Encoder {
    /**
     *   This method acts as the <code>encoder</code> part of the BrowserServlet
     * 
     * @param xsl_source description how to encode the data as XSL Stylesheet
     * @param xml_source data to encode
     * @param writer output
     */
    static protected void encodeInformation(Source xsl_source, Source xml_source , Writer writer){
	javax.xml.transform.TransformerFactory tFactory = javax.xml.transform.TransformerFactory.newInstance();
	javax.xml.transform.Transformer transformer;
	try {
	    transformer = tFactory.newTransformer(xsl_source);
	    // Perform the transformation, sending the output to the response.
	    transformer.transform(xml_source, new javax.xml.transform.stream.StreamResult(writer));		
	} catch (TransformerConfigurationException e) {
	    e.printStackTrace();
	} catch (TransformerException e) {
	    e.printStackTrace();
	}
    }

    static protected void encodeHierarchy(String type, Source xml_source , PrintWriter writer){
	javax.xml.transform.TransformerFactory tFactory = javax.xml.transform.TransformerFactory.newInstance();
	javax.xml.transform.Transformer transformer;
	Source xsl_source = loadHierarchyXSL(type);
	try {
	    transformer = tFactory.newTransformer(xsl_source);
	    // Perform the transformation, sending the output to the response.
	    String header = toString(loadTextFile("/opt/isac/isacxml/xml/pbl/codeheader.html"));
	    String footer = toString(loadTextFile("/opt/isac/isacxml/xml/pbl/codefooter.html"));
	    writer.print(header);
	    transformer.transform(xml_source, new javax.xml.transform.stream.StreamResult(writer));
	    writer.print(footer);
	} catch (TransformerConfigurationException e) {
	    e.printStackTrace();
	} catch (TransformerException e) {
	    e.printStackTrace();
	}
    }
    
    static Source loadHierarchyXSL(String type){
	String xsl_file= "";
	if(type.equals("pbl"))
	    xsl_file="/opt/isac/isacxml/xml/pbl/pbl_hierarchy_jmenu.xsl";
	else if(type.equals("met"))
	    xsl_file="/opt/isac/isacxml/xml/met/met_hierarchy_jmenu.xsl";
	else
	    xsl_file="/opt/isac/isacxml/xml/exp/exp_hierarchy_jmenu.xsl";
	return new StreamSource(loadTextFile(xsl_file));
    }

	static Source loadHContentXSL(String type){
	String xsl_file= "";
	if(type.equals("pbl"))
		xsl_file="/opt/isac/isacxml/xml/pbl/pbl_hcontent.xsl";
	else if(type.equals("met"))
		xsl_file="/opt/isac/isacxml/xml/met/met_hcontent.xsl";
	else
		xsl_file="/opt/isac/isacxml/xml/exp/exp_hcontent.xsl";
	return new StreamSource(loadTextFile(xsl_file));
	}

    private static InputStream loadTextFile(String filename){
	InputStream istream;
	try{
	    istream = (new URL("file", "", filename)).openStream();
	    return istream;
	} catch (MalformedURLException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
 throw new NullPointerException("file not found ! :"+filename);

    }

    protected static String toString(InputStream istream){
	StringBuffer buf = new StringBuffer(10000);
	int input;
	try {
	    while( (input = istream.read()) != -1 ) {
		buf.append((char)input);
	    }
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
	return buf.toString();
    }

	/**
	 * @param type
	 * @param xmlSource
	 * @param out
	 */
	public static void encodeHContent(String type, Source xml_source , PrintWriter writer){
		// TODO Auto-generated method stub
		javax.xml.transform.TransformerFactory tFactory = javax.xml.transform.TransformerFactory.newInstance();
		javax.xml.transform.Transformer transformer;
		Source xsl_source = loadHContentXSL(type);
		try {
			transformer = tFactory.newTransformer(xsl_source);
			// Perform the transformation, sending the output to the response.
			String header = "<html><body>";
			String footer = "</body></html>";
			writer.print(header);
			transformer.transform(xml_source, new javax.xml.transform.stream.StreamResult(writer));
			writer.print(footer);
		} catch (TransformerConfigurationException e) {
			e.printStackTrace();
		} catch (TransformerException e) {
			e.printStackTrace();
		}		
	}
    
}
