/*
 * Created on Aug 21, 2003
 */
package isac.bridge;

/**
 * @author rgradisc
 */

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class Clients2KIServer implements Runnable {
  private ServerSocket server = null;
  private BridgeMain bridge;

  //---------------------------------------------------------------
  public Clients2KIServer(BridgeMain bridge) {
    this.bridge = bridge;
  }

  //---------------------------------------------------------------
  public void listenSocket() {
    ClientOutputWorker w;
    Socket socket;
    try {
      server = new ServerSocket(bridge.getSocketPort());
    } catch (IOException e) {
      bridge.log(1, "Could not listen on port " + bridge.getSocketPort());
    }
    while (true) {
      try {
        //TODO id should be fetched from the ME        
        int id = 1;
        //int id = new Random().nextInt(1000);
        if (server==null) System.out.println("-->server null");
        socket = server.accept(); // wait for client connections
        w = new ClientOutputWorker(id, socket, bridge);
        Thread t = new Thread(w, "java_bridge_clientworker" + id);
        t.setDaemon(true);
        t.start();
        bridge.log(1, "new Client accepted, id=" + id);
        //TODO if to much load, start new kernel: bridge.startNewKernel();

      } catch (IOException e) {
        bridge.log(1, "Accept failed on port" + bridge.getSocketPort());
        System.exit(-1);
      }
    }
  }

  //---------------------------------------------------------------
  public void run() {
    listenSocket();
    try {
      bridge.log(1, "Clients2KIServer: Cleaning up...");
      server.close();

    } catch (IOException e) {
      bridge.log(1, "Could not close socket");
      System.exit(-1);
    }
  }

}
