/****************************************************************** 
* Copyright (c) 2003, Mario Hochreiter, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JPanel;
import javax.swing.JTabbedPane;

/**
 * Panel in the window application that is responsible to layout the
 * browser windows (e.g. example browser). The different browser windows
 * are shown as different tabs in a JTabbedPane. 
 * 
 * @author Mario Hochreiter
 * @version 0.1
 *
 */
public class BrowserPanel extends JPanel {
  /** Contains all "browser" panels like "Example browser". */
  private JTabbedPane browserTabPane;
    
  public BrowserPanel() {
    this.setMinimumSize(new Dimension(200, 200));
    browserTabPane = new JTabbedPane(JTabbedPane.BOTTOM, 
                                     JTabbedPane.SCROLL_TAB_LAYOUT);
    this.setLayout(new BorderLayout());
    this.add(browserTabPane, BorderLayout.CENTER);
    browserTabPane.add("Example Browser", new JPanel());
    browserTabPane.add("Problem Browser", new JPanel());
    browserTabPane.add("Theory Browser", new JPanel());
    browserTabPane.add("Method Browser", new JPanel());       
  }  
}
