/*
 * Created on Sep 11, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package isac.util;

import java.io.Serializable;

/**
 * @author Alan Krempler
 *
 * This is the interface common to all objects which
 * can occur in a calculation tree CalcTree.
 * 
 * @see isac.bridge.CalcTree
 */
public interface CalcElement extends Serializable {
	/**
	 * 
	 * @return A plain text representation of the data stored
	 */
	public String getText();
	/**
	 * 
	 * @return A MathML content representation of the data stored
	 */
	public String getMathML();
	/**
	 * 
	 * @return A integer representing the type of the object
	 * @see CALCEL_FORMULA
	 * @see CALCEL_TACTIC
	 * @see CALCEL_MODSPEC
	 * @see CALCEL_ASSUMPTION 
	 */
	public int getType();
	
	/**
	 * Labels a CalcElement as "Formula"
	 * @see getType()
	 */
	public static final int CALCEL_FORMULA = 1;
	
	/**
	 * Labels a CalcElement as "Tactic"
 	 * @see getType()
	 */
	public static final int CALCEL_TACTIC = 2;
	
	/**
	 * Labels a CalcElement as "ModSpec"
	 * @see getType()
	 */	
	public static final int CALCEL_MODSPEC = 3;
	
	/**
	 * Labels a CalcElement as "Assumption"
	 * @see getType()
	 */
	public static final int CALCEL_ASSUMPTION = 4;
	
	
	
}
