/*
 * Created on Sep 19, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package isac.util;


import java.io.Serializable;

/**
 * @author isac
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface ICalcIterator extends Comparable, Cloneable, Serializable  {

	/**
	* Reference the first (root) element in the attached calculation tree. 
	* @return Like all the moveXXX methods this returns true on success, 
	* false if there is no element to move to. 
	*/
	public boolean moveRoot();
	
	/**
	* Reference the previous formula in the attached calculation tree.
	* @return Like all the moveXXX methods this returns true on success, 
	false if there is no element to move to. 
	*/
	public boolean moveUp();
	
	/**
	Reference the next formula in the attached calculation tree.
	* @return Like all the moveXXX methods this returns true on success, 
	false if there is no element to move to. 
	*/
	public boolean moveDown(); 

	/**
	Enter the next coarser level of refinement in the attached calculation tree.
	* @return Like all the moveXXX methods this returns true on success, 
	false if there is no element to move to. 
	*/
	public boolean moveLevelUp();

	/**
	Enter the next more detailed level of refinement in the 
	attached calculation tree.
	* @return Like all the moveXXX methods this returns true on success, 
	false if there is no element to move to. 
	*/
	public boolean moveLevelDown();

	/**
	Reference the tactic which resulted in the currently selected element of 
	the attached calculation tree. 
	<p>A special case arises if the tactic to continue the current calculation 
	is solving a subproblem. The subproblem is a calculation on its own, 
	represented by a separate calculation(sub-)tree object. A reference to the 
	calculationtree representing the subproblem is passed to the worksheet. 
	The worksheet will handle the situation accordingly, e.g. by opening a new 
	worksheet or displaying the new calculationtree (indented) in the current
	worksheet. 
	* @return Like all the moveXXX methods this returns true on success, 
	false if there is no element to move to. 
	*/
	public boolean moveTactic();

	/**
	Reference the formula which resulted in the currently selected element 
	of the attached calculation tree.
	*/
	public boolean moveFormula() ;


	/**
	 * Use this to get the current element and check
	 * the type by calling getType().
	 * 
	 * @return The currently referenced Element
	 * @see getType()
	 */
	public CalcElement getElement();
	
	/**
	??? SDD refFormula
	* @return 
	*/ 
	// public Formula getFormula() ;

	/**
	??? SDD refTactic
	* @return 
	*/ 
	// public Tactic getTactic() ;

	/**
	The current level of nesting into subcalculations.
	* @return An int representing level of nesting (higher == more detailed)
	<p>Special values:
	<p>0: outmost level: only first and last step of calculation are on this level 
	*/ 
	public int getLevel();	
  
  public Object clone();
}
