/*
 * Created on Sep 19, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package isac.util;

import java.io.Serializable;


/**
 * @author isac
 * Abstract base class for elements of the ModSpec object.
 * Implements the status functionality common to all ModSpec elements.
 * @see ModSpec
 */

public abstract class ModSpecElement implements Serializable {

	protected int status_ = ModSpec.MODSPEC_INCOMPLETE;
	

	/**
	 * @return Completion status as seen in the context of the ModSpec
	 * 
	 * @see ModSpec
	 * @see ModSpec.MODSPEC_CORRECT
	 * @see ModSpec.MODSPEC_INCORRECT
	 * @see ModSpec.MODSPEC_SYNTAXERROR
	 * @see ModSpec.MODSPEC_INCOMPLETE
	 * @see ModSpec.MODSPEC_FALSE
	 */
	public int getStatus() {
		return status_;
	}

	/**
	 * @param status new status of this ModSpec element
	 * 
	 * @see ModSpec
	 * @see ModSpec.MODSPEC_CORRECT
	 * @see ModSpec.MODSPEC_INCORRECT
	 * @see ModSpec.MODSPEC_SYNTAXERROR
	 * @see ModSpec.MODSPEC_INCOMPLETE
	 * @see ModSpec.MODSPEC_FALSE

	 */
	public void setStatus(int status) {
		status_ = status;
	}

}
