/****************************************************************** 
* Copyright (c) 2003, Mario Hochreiter, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.wsdialog;

import isac.bridge.CalcTree;
import isac.util.*;
import isac.util.ModSpec;
import isac.util.Tactic;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * @author Mario Hochreiter
 * @version 1.0
 *
 */
public interface DGuide extends Remote {
  
  public void attach(CalcTree calc_tree) throws RemoteException;

  public void reDisplay() throws RemoteException;
  
  public void newCalculation(ModSpec mod_spec) throws RemoteException;

  public void calcChanged(CalcChangedEvent event) throws RemoteException;

  public ICalcIterator iterator() throws RemoteException;

  public boolean addListener(IToUser listener) throws RemoteException;
  
  public Tactic fetchProposedTactic() throws RemoteException;
  
  public void setNextTactic(Tactic tactic) throws RemoteException;
}
